searchData={"items":[{"type":"module","title":"GeoIP","doc":"Elixir library to lookup the geo location for an IP address or hostname using freegeoip.net","ref":"GeoIP.html"},{"type":"module","title":"Examples - GeoIP","doc":"iex> GeoIP.lookup(\"google.com\")\n    {:ok,\n     %{\n      city: \"San Francisco\",\n      country_code: \"US\",\n      country_name: \"United States\",\n      ip: \"192.30.253.113\",\n      latitude: 37.7697,\n      longitude: -122.3933,\n      metro_code: 807,\n      region_code: \"CA\",\n      region_name: \"California\",\n      time_zone: \"America/Los_Angeles\",\n      zip_code: \"94107\"\n      }\n    }","ref":"GeoIP.html#module-examples"},{"type":"function","title":"GeoIP.lookup/1","doc":"Lookup the location for the given IP address/hostname.\n\nArgs:\n  * `host` - The IP/hostname or Plug.Conn instance to use for the lookup. The IP can be either a string or a tuple.\n\nThis function returns `{:ok, response}` if the lookup is successful, `{:error, %GeoIP.Error{reason: reason}}` otherwise.","ref":"GeoIP.html#lookup/1"},{"type":"function","title":"Examples - GeoIP.lookup/1","doc":"{:ok, location} = GeoIP.lookup({8, 8, 8, 8})\n    {:ok, location} = GeoIP.lookup(\"8.8.8.8\")\n    {:ok, location} = GeoIP.lookup(\"google.com\")\n    {:ok, location} = GeoIP.lookup(conn)         # A `Plug.Conn` instance","ref":"GeoIP.html#lookup/1-examples"},{"type":"function","title":"GeoIP.start/2","doc":"","ref":"GeoIP.html#start/2"},{"type":"module","title":"GeoIP.Config","doc":"","ref":"GeoIP.Config.html"},{"type":"function","title":"GeoIP.Config.api_key/0","doc":"","ref":"GeoIP.Config.html#api_key/0"},{"type":"function","title":"GeoIP.Config.api_key!/0","doc":"","ref":"GeoIP.Config.html#api_key!/0"},{"type":"function","title":"GeoIP.Config.cache_enabled?/0","doc":"","ref":"GeoIP.Config.html#cache_enabled?/0"},{"type":"function","title":"GeoIP.Config.cache_ttl_secs/0","doc":"","ref":"GeoIP.Config.html#cache_ttl_secs/0"},{"type":"function","title":"GeoIP.Config.default_test_result/0","doc":"","ref":"GeoIP.Config.html#default_test_result/0"},{"type":"function","title":"GeoIP.Config.extra_params/0","doc":"","ref":"GeoIP.Config.html#extra_params/0"},{"type":"function","title":"GeoIP.Config.provider!/0","doc":"","ref":"GeoIP.Config.html#provider!/0"},{"type":"function","title":"GeoIP.Config.test_results/0","doc":"","ref":"GeoIP.Config.html#test_results/0"},{"type":"function","title":"GeoIP.Config.url!/0","doc":"","ref":"GeoIP.Config.html#url!/0"},{"type":"function","title":"GeoIP.Config.use_https/0","doc":"","ref":"GeoIP.Config.html#use_https/0"},{"type":"module","title":"GeoIP.Lookup","doc":"","ref":"GeoIP.Lookup.html"},{"type":"function","title":"GeoIP.Lookup.lookup/1","doc":"","ref":"GeoIP.Lookup.html#lookup/1"},{"type":"exception","title":"GeoIP.Error","doc":"","ref":"GeoIP.Error.html"},{"type":"function","title":"GeoIP.Error.message/1","doc":"","ref":"GeoIP.Error.html#message/1"},{"type":"type","title":"GeoIP.Error.t/0","doc":"","ref":"GeoIP.Error.html#t:t/0"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased]","ref":"changelog.html"},{"type":"extras","title":"v0.2.7 - 2021-09-03 - Changelog","doc":"- Bumped httpoison and cachex to eliminate deprecation warnings\n- Dropped support for Elxir < 1.5","ref":"changelog.html#v0-2-7-2021-09-03"},{"type":"extras","title":"v0.2.6 - 2019-10-04 - Changelog","doc":"- [#14](https://github.com/navinpeiris/geoip/pull/14) :extra_params config option","ref":"changelog.html#v0-2-6-2019-10-04"},{"type":"extras","title":"v0.2.5 - 2019-08-13 - Changelog","doc":"- Use [jason](https://github.com/michalmuskala/jason) instead of [poison](https://github.com/devinus/poison).","ref":"changelog.html#v0-2-5-2019-08-13"},{"type":"extras","title":"v0.2.4 - 2019-08-13 - Changelog","doc":"- [#13](https://github.com/navinpeiris/geoip/pull/13) Compatibility with Poison v4.0","ref":"changelog.html#v0-2-4-2019-08-13"},{"type":"extras","title":"v0.2.3 - 2018-09-05 - Changelog","doc":"- Fixes issue where the `test` provider wasn't returning configured results for localhost.","ref":"changelog.html#v0-2-3-2018-09-05"},{"type":"extras","title":"v0.2.2 - 2018-09-05 - Changelog","doc":"- Adds a `test` provider for returning lookup data in test environments.","ref":"changelog.html#v0-2-2-2018-09-05"},{"type":"extras","title":"v0.2.0 - 2018-07-10 - Changelog","doc":"- Provides integrations with [ipstack.com](http://ipstack.com) and [ipinfo.io](http://ipinfo.io).\n\n#","ref":"changelog.html#v0-2-0-2018-07-10"},{"type":"extras","title":"Breaking Changes - Changelog","doc":"- We don't default to using `freegeoip.net` as we used to as that service has now been deprecated. Instead the provider must be explicity provided. Please see the [README](https://github.com/navinpeiris/geoip/blob/master/README.md) for more details.\n\n- The `GeoIP.lookup` function no longer returns a `GeoIP.Location` struct. Instead, it returns the parses response returned by the configured provider, with they keys converted to atoms. This was so ease the integration with multiple providers and so that we don't have to release a new version of this library every time a providers response format changes.","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"v0.1.4 - 2018-05-29 - Changelog","doc":"- [#9](https://github.com/navinpeiris/geoip/pull/9) Update Cachex to version 3.0","ref":"changelog.html#v0-1-4-2018-05-29"},{"type":"extras","title":"License","doc":"The MIT License\n\nCopyright (c) 2016-present Navin Peiris\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the \"Software\"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# GeoIP\n\n[![Build Status](https://travis-ci.org/navinpeiris/geoip.svg?branch=master)](https://travis-ci.org/navinpeiris/geoip)\n[![Module Version](https://img.shields.io/hexpm/v/geoip.svg)](https://hex.pm/packages/geoip)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/geoip/)\n[![Total Download](https://img.shields.io/hexpm/dt/geoip.svg)](https://hex.pm/packages/geoip)\n[![License](https://img.shields.io/hexpm/l/geoip.svg)](https://github.com/navinpeiris/geoip/blob/master/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/navinpeiris/geoip.svg)](https://github.com/navinpeiris/geoip/commits/master)\n\nElixir library to lookup the geographic location for a given IP address, hostname, or `Plug.Conn`.\n\nThe returned results are cached for an hour by default so that we don't hit the service unnecessarily, but this is configurable can be disabled using the config options (see below).","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"Add `:geoip` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:geoip, \"~> 0.2\"}\n  ]\nend\n```\n\nUpdate your mix dependencies:\n\n```elixir\nmix deps.get\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Overview","doc":"#","ref":"readme.html#configuration"},{"type":"extras","title":"Provider - Overview","doc":"The provider must be explicitly specified along with any required attributes as per examples below.\n\n##","ref":"readme.html#provider"},{"type":"extras","title":"freegeoip - Overview","doc":"The free host that was available at `freegeoip.net` and the corresponding source repository at\n[fiorix/freegeoip](https://github.com/fiorix/freegeoip) was deprecated in the middle of 2018, but\nit still allows you to launch your own instance if you wish.\n\n```elixir\nconfig :geoip, provider: :freegeoip, url: \"https://geoip.example.com\"\n```\n\n##","ref":"readme.html#freegeoip"},{"type":"extras","title":"ipstack - Overview","doc":"[ipstack](https://ipstack.com) provides a free tier although it requires you to sign up and get an api key first.\n\nNOTE: The free tier does not allow https access so you _must_ specify `use_https: false` below.\n\n```elixir\nconfig :geoip, provider: :ipstack, api_key: \"your-api-key\"\n```\n\n##","ref":"readme.html#ipstack"},{"type":"extras","title":"ipinfo - Overview","doc":"[ipinfo](https://ipinfo.io) does not unfortunately support lookup by hostname (only ip address), therefore the above examples where a hostname is used will return an error.\n\n```elixir\nconfig :geoip, provider: :ipinfo, api_key: \"your-api-key\"\n```\n\n##","ref":"readme.html#ipinfo"},{"type":"extras","title":"test - Overview","doc":"Provides an easy way to provide mock lookup data in test environments.\n\nThe `test_results` param is a map of host to lookup results that should be returned. If the ip/host looked up is not found in this map, then the results provided by the `default_test_result` param is provided.\n\n```elixir\nconfig :geoip,\n  provider: :test,\n  test_results: %{ # optional\n   \"host.1\" => %{\n     ip: \"123.123.123.123\",\n     # ......\n   },\n   \"host.2\" => %{\n     ip: \"1.1.1.1\",\n     # ......\n   },\n  },\n  default_test_result: %{ # optional\n   ip: \"192.168.3.3\",\n   # ......\n  }\n```\n\n#","ref":"readme.html#test"},{"type":"extras","title":"Caching - Overview","doc":"By default, the location results returned by the freegeoip server is cached for an hour. We can disable the cache by:\n\n```elixir\nconfig :geoip, cache: false\n```\n\nOr to change the time limit of cached results:\n\n```elixir\nconfig :geoip, cache_ttl_secs: 1800 # 30 mins\n```\n\n#","ref":"readme.html#caching"},{"type":"extras","title":"Extra parameters - Overview","doc":"You can add extra query parameters to geoip service requests via `:extra_params` config option:\n\n```elixir\nconfig :geoip, extra_params: [language: \"RU\"]\n```","ref":"readme.html#extra-parameters"},{"type":"extras","title":"Usage - Overview","doc":"You can pass in an IP address (as a string or a struct), hostname or a `Plug.Conn` struct to be looked up.\n\n```elixir\nGeoIP.lookup(\"google.com\")\n#=> {:ok, %{city: \"Mountain View\", country_code: \"US\", country_name: \"United States\", ip: \"172.217.4.78\", latitude: 37.4192, longitude: -122.0574, metro_code: 807, region_code: \"CA\", region_name: \"California\", time_zone: \"America/Los_Angeles\", zip_code: \"94043\"}}\n\n# Other examples:\nGeoIP.lookup(\"8.8.8.8\")\nGeoIP.lookup({8, 8, 8, 8})\nGeoIP.lookup(conn)\n```\n\nThis returns `{:ok, response}` if the lookup is successful, `{:error, %GeoIP.Error{reason: reason}}` otherwise.","ref":"readme.html#usage"},{"type":"extras","title":"Testing - Overview","doc":"Please see the `test` provider above.","ref":"readme.html#testing"},{"type":"extras","title":"Determining your `remote_ip` when behind a proxy - Overview","doc":"If your application is running behind a proxy, we recommend using [ajvondrak/remote_ip](https://github.com/ajvondrak/remote_ip) or something similar to override the `remote_ip` field of `Plug.Conn`. Due to the various different ways of determining the applications remote ip depending on your deployment environment, we leave this up to you to configure as appropriate.","ref":"readme.html#determining-your-remote_ip-when-behind-a-proxy"},{"type":"extras","title":"GeoIP logo - Overview","doc":"Special thanks to [@batarian71](https://github.com/batarian71) for designing and providing this project with an awesome logo","ref":"readme.html#geoip-logo"},{"type":"extras","title":"Related Packages - Overview","doc":"* https://github.com/elixir-geolix/geolix If you want to use the [MaxMind files directly](https://github.com/navinpeiris/geoip/issues/1)\n* https://github.com/knrz/geocoder\n* https://github.com/amotion-city/lib_lat_lon","ref":"readme.html#related-packages"},{"type":"extras","title":"Copyright and License - Overview","doc":"Copyright (c) 2016 Navin Peiris\n\nThis work is free. You can redistribute it and/or modify it under the\nterms of the MIT License. See the [LICENSE.md](./LICENSE.md) file for more details.","ref":"readme.html#copyright-and-license"}],"content_type":"text/markdown"}